package mods.immibis.ars.beams;

import ic2.api.energy.tile.IEnergySink;
import mods.immibis.core.api.APILocator;
import mods.immibis.core.api.crossmod.ICrossModIC2;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.tileentity.TileEntity;
import net.minecraftforge.common.ForgeDirection;

public class TileEMPUpgrade extends TileBeamEmitter implements IEnergySink {
	public static final int MAX_STORAGE = 1000000;
	
	public int storage;
	
	private boolean added_to_enet;
	
	private ICrossModIC2 ic2 = APILocator.getCrossModIC2();
	
	private UpgradeData upg_data;
	public TileEMPUpgrade() {
		upg_data = new UpgradeData();
		upg_data.emp = this;
	}
	
	@Override
	public void readFromNBT(NBTTagCompound tag) {
		super.readFromNBT(tag);
		storage = tag.getInteger("eu");
	}
	
	@Override
	public void writeToNBT(NBTTagCompound tag) {
		super.writeToNBT(tag);
		tag.setInteger("eu", storage);
	}
	
	@Override
	public void invalidate() {
		if(added_to_enet) {
			ic2.removeEnetTile(this);
			added_to_enet = false;
		}
		super.invalidate();
	}
	
	@Override
	public void onChunkUnload() {
		if(added_to_enet) {
			ic2.removeEnetTile(this);
			added_to_enet = false;
		}
		super.onChunkUnload();
	}
	
	@Override
	public Object getOutput() {
		return upg_data;
	}
	
	@Override
	public void updateEntity() {
		if(worldObj.isRemote)
			return;
		
		if(!added_to_enet) {
			ic2.addEnetTile(this);
			added_to_enet = true;
		}
	}

	@Override
	public boolean acceptsEnergyFrom(TileEntity arg0, ForgeDirection arg1) {
		return true;
	}
	
	@Override
	public double demandedEnergyUnits() {
		return MAX_STORAGE - storage;
	}
	
	@Override
	public double injectEnergyUnits(ForgeDirection arg0, double arg1) {
		if(storage >= MAX_STORAGE)
			return arg1;
		else {
			storage += (int)arg1;
			return arg1 - (int)arg1;
		}
	}
	
	@Override
	public int getBeamColour() {return 1;}
	
	@Override
	public int getMaxSafeInput() {
		return Integer.MAX_VALUE;
	}
}
